Redmine - Feature #1561

Totals for estimated/spent time and numeric custom fields on the issue list
2008-07-02 12:16 - Ewan Makepeace

Status: Closed Start date: 2008-07-02
Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 3.2.0

Resolution: Fixed

Description

| am constantly juggling tasks to try and assign each developer approximately the correct number of tasks for the months sprint,
counting up how many tasks are outstanding for the next release and counting how many man days have been completed by each
developer for bonus purposes. In redmine this involves manually adding up the estimated time values for each task in a list, which
gets tedious and error prone.

I would like to request a total row on issues lists when estimated time column is shown.

Ideally | would also like a subtotal for each value in the sorted column (typically sorted by assigned to, so a subtotal per developer,
but could be anything).

| suspect | am in a minority with this request but as the number of issues at hand increases | really dont need to be squinting at the
screen adding up numbers in my head...

Related issues:

Related to Redmine - Patch #2268: Patch to show Total Estimated Time at the b... Closed 2008-12-03
Related to Redmine - Patch #4776: Totals for Estimated Time Closed 2010-02-09
Related to Redmine - Feature #6571: Totalise numeric columns Closed 2010-10-05
Related to Redmine - Feature #8559: Sum columns in reports Closed 2011-06-07
Related to Redmine - Feature #21413: Totals for custom field with different f... Closed

Related to Redmine - Feature #21390: Adjust total values for numeric columns ... New

Has duplicate Redmine - Feature #13935: Add cumulative affected time to issue... Closed

Has duplicate Redmine - Feature #14384: Add column "spent time" on list issues Closed

Has duplicate Redmine - Feature #18263: Group in issue list should provide no... Closed

Has duplicate Redmine - Feature #5311: Sums in the groupped task report Closed 2010-04-14

Associated revisions

Revision 14642 - 2015-10-04 21:42 - Jean-Philippe Lang
Adds options to display totals on the issue list (#1561).

Works for estimated hours, spent hours and any numeric custom field.

Revision 14643 - 2015-10-04 21:43 - Jean-Philippe Lang
Adds :label_total_plural to locales (#1561).

Revision 14644 - 2015-10-05 00:16 - Jean-Philippe Lang
Round totals (#1561).

Revision 14665 - 2015-10-09 11:02 - Jean-Philippe Lang
Display totals for each group on grouped queries (#1561).

Revision 14666 - 2015-10-09 11:02 - Jean-Philippe Lang
Display totals if the PDF export (#1561).

Revision 14667 - 2015-10-09 11:30 - Jean-Philippe Lang
Workaround for spent time grouped by project (#1561).

Revision 14668 - 2015-10-09 14:44 - Jean-Philippe Lang
Fixes float conversion failures (#1561).

History

#1 - 2008-07-02 22:47 - Boudewijn van Liempd

+1

I would also like to see a sum of the estimated time on certain places. | would also like to use it for planning purposes, although in a slightly different
way. We do not use redmine solely for software projects but also to plan issues where we know upfront how many hours it is going to take.

It would be nice to have also in the gantt chart, e.g. see the total estimated hours per day (using the starting day to show the number).
#2 - 2008-07-08 15:06 - Anna Labinskaya
+1

We also need an aggregated report on estimated time. Maybe this could be built by extending the report on Spent time? Or as a separate report -- it
would be helpful too.

BTW, it would also be useful to see a number of issues not yet estimated. It could be a link to a list of such issues.

#3 - 2008-07-08 16:14 - Michael Pirogov

- File timeplan.png added

Hi there :-)

I'm working on plugin, which maybe would get your attention.

It's based on timesheet plugin (by E. Devis), but it's AJAX powered and have some more features against estimated time tracking.

The goal is to get a helper for a visual office-planning.

Sorry, | don't have much time on it, so it's not fully translated for now, no gantted and has some lags/bugs/craps and so on...

But you can take a look on a screenshot, I've attached.

Hope, it'll be done ASAP.

Basic feature is a split hours by days. If there's no estimated time specified, then fulltime is counted (6 hours per day ;-) ).

#4 - 2008-07-08 18:47 - Anna Labinskaya

Hi Michael!

Thanks for the screenshot. Looks promising to me.

Actually we are also interested in a breakdown of remaining time (which is a sum of estimates minus spent time for all non-closed tickets) by
Category, developer, etc. The % Done bar shown on your screenshot isn't quite an indication (to us) of the remaining time (just with our process we
are used to) as the % Done field is set manually rather then gets calculated automatically based on estimated and spent time for an issue.
Understand that it's a question of preferences/selected process -- how to record progress. What's currently implemented in Redmine is recording
progress by manually setting the % Done. And the spent time logging/reporting is sort of additional. We in our case are more for updating the estimate

field instead -- when we see that the remaining time shown in our planning tool isn't sufficient to complete the task. Just we are used to the XPlanner's
model for time metrics :-)

#5 - 2008-07-21 17:22 - Eric Davis
Michael Pirogov wrote:
I'm working on plugin, which maybe would get your attention.

It's based on timesheet plugin (by E. Devis), but it's AJAX powered and have some more features against estimated time tracking.

Micheal, do you have a public code repository for this plugin? | could lend a development hand or two.
Anna Labinskaya wrote:

Actually we are also interested in a breakdown of remaining time (which is a sum of estimates minus spent time for all non-closed tickets) by
Category, developer, etc.

I've been wanting to build a plugin that would show estimate progress for a project. It would use progress bars and would "fill up" as time is spent
towards an estimate. | think it should also change colors from green to yellow to red as the time spent reaches and surpasses an estimate.

#6 - 2008-07-21 19:08 - Anna Labinskaya

- File time-breakdown.PNG added

Eric Davis wrote:
I've been wanting to build a plugin that would show estimate progress for a project. It would use progress bars and would "fill up" as time is
spent towards an estimate. | think it should also change colors from green to yellow to red as the time spent reaches and surpasses an
estimate.

Guys, take a look at our version (implemented by Artem Vasiliev, he's going to submit a patch soon today): time-breakdown.PNG

It's an extension to the existing Version (milestone) screen and shows aggregate time metrics in addition to the numbers of issues. Remaining time is
Estimated minus Spent for all open issues.

Eric, changing colors would be nice.
#7 - 2008-07-21 19:34 - Artem Vasiliev
Anna Labinskaya wrote:

Guys, take a look at our version (implemented by Artem Vasiliev, he's going to submit a patch soon today): time-breakdown.PNG

Here it is: #1671
Please take a look :)

#8 - 2008-12-03 03:47 - Ewan Makepeace

We ended up coding a simple total for estimated time of visible issues (see attached). If there is interest will upload as a patch.

#9 - 2008-12-03 03:47 - Ewan Makepeace
- File Picture_1.jpg added

Ewan Makepeace wrote:

We ended up coding a simple total for estimated time of visible issues (see attached). If there is interest will upload as a patch.

#10 - 2008-12-03 04:55 - Ewan Makepeace
Patch filed here: #2268

#11 - 2009-01-19 06:42 - Ewan Makepeace
- File Screenshot_10.jpg added

We are now patching the issue summary report to show both issue count and total estimated time. If you look at the attached screenshot you will see
how one this appears - it is very useful to quickly see where effort should be focussed, where issue count is less useful.

If others are interested will post this is a patch.

#12 - 2009-01-19 06:48 - Ewan Makepeace
- File Screenshot_11.jpg added

Sorry - wrong screenshot!

#13 - 2009-02-09 10:23 - Vladimir Oleynik

Michael Pirogov wrote:

I'm working on plugin, which maybe would get your attention.

Michael, have you finished that timeplan plugin?
the screen mockup you uploaded is pretty nice, but failed to find any plugin/patch to get such screen. (I don't need it translated).
https://www.redmine.org/issues/1671
https://www.redmine.org/issues/2268

#14 - 2011-10-26 06:13 - Mischa The Evil

As mentioned the first time by Tony Marschall in #8559 note-4, there exists a plugin which provides (parts of) this feature (along with some others):
Redmine spent time column. It's written by Jan Schulz-Hofen of plan.io.

I've started working on some improvements to make it better suitable for this issue in my fork of it:
https://github.com/MischaTheEvil/redmine_spent_time_column

#15 - 2015-10-04 21:43 - Jean-Philippe Lang

- Category changed from Ul to Issues

- Assignee set to Jean-Philippe Lang

- Target version set to 3.2.0

#16 - 2015-10-04 21:46 - Jean-Philippe Lang

r14642 makes it possible to display totals for estimated hours, spent hours and any numeric custom field.

Totals that are displayed by default can be configured in the application settings.

#17 - 2015-10-04 23:05 - Sebastian Paluch

Jean-Philippe Lang wrote:

r14642 makes it possible to display totals for estimated hours, spent hours and any numeric custom field.
Totals that are displayed by default can be configured in the application settings.

That is awesome! Will it work also for grouped queries? Will it show totals for each group and for entire query?

#18 - 2015-10-05 00:25 - Jean-Philippe Lang

Will it show totals for each group

Not implemented yet but it should be done soon.

#19 - 2015-10-09 11:11 - Jean-Philippe Lang
- File totals.png added

Totals for groups are now added, including in the PDF export as well. Here is the final result:

Group resufts by Tracker -
Show Description
Totals ¥| Estimated tme [§#] Spent time Integer CF Float CF
o Apoly @ Clear i Save Estimated time: 79.90 Spent time: 39.50
¢ # Tracker Priority Subject
Defect 56,30 15.50
17163 Defect Normal Files assigned to a version can not be deleted if Issue Tracking module is disabled
16422 Defect Normal 1In attachment.rb thumbnail function could not return target correct
15694 Defect MNormal Error while uploading attachments

There's still an issue with queries grouped by projects because of this: https:/github.com/rails/rails/issues/21922

#20 - 2015-10-09 11:31 - Jean-Philippe Lang

- Subject changed from Please provide totals for the estimated time column to Totals for estimated/spent time and numeric custom fields on the issue
list

- Status changed from New to Closed
- Resolution set to Fixed
Jean-Philippe Lang wrote:

There's still an issue with queries grouped by projects because of this: https:/github.com/rails/rails/issues/21922

Workaround applied in r14667.
#21 - 2015-12-01 14:27 - Sebastian Paluch

The feature is very, very useful but after working with it for a while it seems that it would be more practical if total values would show up under right

columns instead single summary line. It would be much more readable. | have added #21390 to track it separately.

#22 - 2015-12-05 11:01 - Jean-Philippe Lang

- Related to Feature #21413: Totals for custom field with different field format added

#23 - 2015-12-30 11:52 - Toshi MARUYAMA

- Related to Feature #21390: Adjust total values for numeric columns layout to match columns added

#24 - 2016-01-04 12:01 - Go MAEDA

- Has duplicate Feature #13935: Add cumulative affected time to issue list view added

#25 - 2016-01-10 03:11 - Go MAEDA

- Has duplicate Feature #14384: Add column "spent time" on list issues added

#26 - 2016-08-21 02:52 - Go MAEDA

- Has duplicate Feature #18263: Group in issue list should provide no. of estimated time vs spent time besides just providing total issues added

#27 - 2020-03-05 00:32 - Go MAEDA

- Has duplicate Feature #5311: Sums in the groupped task report added
